/*!
* distribute.it
* Copyright (c) 2011 Peter Sunde <peter.sunde@gmail.com>
* MIT Licensed
*/

var util = require('.././lib/core/util.js')
    , fs = require('fs')
    , assert = require('assert');

exports['create a recursive folder structure'] = function(done) {
    var current = ''
        , i = 1
        , directories = "tmp/directory/folder/recursive/map/ninja/ninja2".split("/");
    directories.forEach(function(directory) {
        if(!current) {
            current = './' + directory;
        } else {
            current += "/" + directory;
        }
        try {
            fs.mkdirSync(current,  0755);
            fs.writeFileSync(current + "/" + 'test' + i + '.js', 'random test');
            if(i === directories.length) done();
            i++;
        } catch(e) { done(); };
    });
}

exports['get a recursive list of files'] = function(done) {
    var path = process.cwd() + "/tmp";
    util.readdir(path, function(err, files) {
        assert.equal(err, null);
        assert.equal(Array.isArray(files), true);
        assert.equal(files.length, 7);    
        done();
    });
}
